/*
BotV2

Bot API v2

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package botapiv2

import (
	"encoding/json"
)

// checks if the Asset type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &Asset{}

// Asset struct for Asset
type Asset struct {
	Id string `json:"id"`
	Type AssetType `json:"type"`
	Translations []AssetTranslation `json:"translations"`
	DefaultMedia *AssetMedia `json:"default_media,omitempty"`
	SkipAutoTranslation *bool `json:"skip_auto_translation,omitempty"`
}

// NewAsset instantiates a new Asset object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewAsset(id string, type_ AssetType, translations []AssetTranslation) *Asset {
	this := Asset{}
	this.Id = id
	this.Type = type_
	this.Translations = translations
	return &this
}

// NewAssetWithDefaults instantiates a new Asset object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewAssetWithDefaults() *Asset {
	this := Asset{}
	return &this
}

// GetId returns the Id field value
func (o *Asset) GetId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Id
}

// GetIdOk returns a tuple with the Id field value
// and a boolean to check if the value has been set.
func (o *Asset) GetIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Id, true
}

// SetId sets field value
func (o *Asset) SetId(v string) {
	o.Id = v
}

// GetType returns the Type field value
func (o *Asset) GetType() AssetType {
	if o == nil {
		var ret AssetType
		return ret
	}

	return o.Type
}

// GetTypeOk returns a tuple with the Type field value
// and a boolean to check if the value has been set.
func (o *Asset) GetTypeOk() (*AssetType, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Type, true
}

// SetType sets field value
func (o *Asset) SetType(v AssetType) {
	o.Type = v
}

// GetTranslations returns the Translations field value
func (o *Asset) GetTranslations() []AssetTranslation {
	if o == nil {
		var ret []AssetTranslation
		return ret
	}

	return o.Translations
}

// GetTranslationsOk returns a tuple with the Translations field value
// and a boolean to check if the value has been set.
func (o *Asset) GetTranslationsOk() ([]AssetTranslation, bool) {
	if o == nil {
		return nil, false
	}
	return o.Translations, true
}

// SetTranslations sets field value
func (o *Asset) SetTranslations(v []AssetTranslation) {
	o.Translations = v
}

// GetDefaultMedia returns the DefaultMedia field value if set, zero value otherwise.
func (o *Asset) GetDefaultMedia() AssetMedia {
	if o == nil || IsNil(o.DefaultMedia) {
		var ret AssetMedia
		return ret
	}
	return *o.DefaultMedia
}

// GetDefaultMediaOk returns a tuple with the DefaultMedia field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Asset) GetDefaultMediaOk() (*AssetMedia, bool) {
	if o == nil || IsNil(o.DefaultMedia) {
		return nil, false
	}
	return o.DefaultMedia, true
}

// HasDefaultMedia returns a boolean if a field has been set.
func (o *Asset) HasDefaultMedia() bool {
	if o != nil && !IsNil(o.DefaultMedia) {
		return true
	}

	return false
}

// SetDefaultMedia gets a reference to the given AssetMedia and assigns it to the DefaultMedia field.
func (o *Asset) SetDefaultMedia(v AssetMedia) {
	o.DefaultMedia = &v
}

// GetSkipAutoTranslation returns the SkipAutoTranslation field value if set, zero value otherwise.
func (o *Asset) GetSkipAutoTranslation() bool {
	if o == nil || IsNil(o.SkipAutoTranslation) {
		var ret bool
		return ret
	}
	return *o.SkipAutoTranslation
}

// GetSkipAutoTranslationOk returns a tuple with the SkipAutoTranslation field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Asset) GetSkipAutoTranslationOk() (*bool, bool) {
	if o == nil || IsNil(o.SkipAutoTranslation) {
		return nil, false
	}
	return o.SkipAutoTranslation, true
}

// HasSkipAutoTranslation returns a boolean if a field has been set.
func (o *Asset) HasSkipAutoTranslation() bool {
	if o != nil && !IsNil(o.SkipAutoTranslation) {
		return true
	}

	return false
}

// SetSkipAutoTranslation gets a reference to the given bool and assigns it to the SkipAutoTranslation field.
func (o *Asset) SetSkipAutoTranslation(v bool) {
	o.SkipAutoTranslation = &v
}

func (o Asset) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o Asset) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["id"] = o.Id
	toSerialize["type"] = o.Type
	toSerialize["translations"] = o.Translations
	if !IsNil(o.DefaultMedia) {
		toSerialize["default_media"] = o.DefaultMedia
	}
	if !IsNil(o.SkipAutoTranslation) {
		toSerialize["skip_auto_translation"] = o.SkipAutoTranslation
	}
	return toSerialize, nil
}

type NullableAsset struct {
	value *Asset
	isSet bool
}

func (v NullableAsset) Get() *Asset {
	return v.value
}

func (v *NullableAsset) Set(val *Asset) {
	v.value = val
	v.isSet = true
}

func (v NullableAsset) IsSet() bool {
	return v.isSet
}

func (v *NullableAsset) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableAsset(val *Asset) *NullableAsset {
	return &NullableAsset{value: val, isSet: true}
}

func (v NullableAsset) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableAsset) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


